// TnB3.cpp
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    SendDlgItemMessage(hwnd, cmb1, CB_ADDSTRING, 0, (LPARAM)TEXT("DT_TOP"));
    SendDlgItemMessage(hwnd, cmb1, CB_ADDSTRING, 0, (LPARAM)TEXT("DT_VCENTER"));
    SendDlgItemMessage(hwnd, cmb1, CB_ADDSTRING, 0, (LPARAM)TEXT("DT_BOTTOM"));
    SendDlgItemMessage(hwnd, cmb1, CB_SETCURSEL, 1, 0);
    return TRUE;
}

void OnCmb1(HWND hwnd)
{
    InvalidateRect(hwnd, NULL, TRUE);
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    case IDCANCEL:
        EndDialog(hwnd, id);
        break;
    case cmb1:
        if (codeNotify == CBN_SELCHANGE)
        {
            OnCmb1(hwnd);
        }
        break;
    }
}

void OnDraw(HWND hwnd, HDC hDC)
{
    SetBkMode(hDC, TRANSPARENT);

    RECT rc, rc1, rc2;
    GetClientRect(hwnd, &rc);

    SIZE siz, sizText;
    siz.cx = rc.right - rc.left;
    siz.cy = rc.bottom - rc.top;

    SelectObject(hDC, GetStockObject(BLACK_PEN));
    MoveToEx(hDC, 0, siz.cy / 2, NULL);
    LineTo(hDC, siz.cx, siz.cy / 2);

    TCHAR szText[256] = TEXT("TestTest");

    RECT rcText;
    SetRect(&rcText, rc.left + siz.cx / 3, rc.top + siz.cy / 2,
                     rc.left + siz.cx * 2 / 3, rc.top + siz.cy / 2);

    UINT uFormat = DT_SINGLELINE | DT_LEFT | DT_CALCRECT;
    INT i = (INT)SendDlgItemMessage(hwnd, cmb1, CB_GETCURSEL, 0, 0);
    switch (i)
    {
    case 0:
        uFormat |= DT_TOP;
        break;
    case 1:
        uFormat |= DT_VCENTER;
        break;
    case 2:
        uFormat |= DT_BOTTOM;
        break;
    }
    rc1 = rcText;
    DrawText(hDC, szText, lstrlen(szText), &rcText, uFormat);
    rc2 = rcText;
    uFormat &= ~DT_CALCRECT;
    DrawText(hDC, szText, lstrlen(szText), &rcText, uFormat);

    GetTextExtentPoint32(hDC, szText, lstrlen(szText), &sizText);

    SelectObject(hDC, GetStockObject(BLACK_PEN));
    MoveToEx(hDC, siz.cx / 3, 0, NULL);
    LineTo(hDC, siz.cx / 3, siz.cy);

    wsprintf(szText, TEXT("(%d, %d)\n(%d, %d) - (%d, %d)\n(%d, %d) - (%d, %d)"),
        sizText.cx, sizText.cy,
        rc1.left, rc1.top, rc1.right, rc1.bottom,
        rc2.left, rc2.top, rc2.right, rc2.bottom);
    DrawText(hDC, szText, lstrlen(szText), &rc, DT_TOP | DT_LEFT | DT_NOCLIP | DT_NOPREFIX);
}

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    if (HDC hDC = BeginPaint(hwnd, &ps))
    {
        OnDraw(hwnd, hDC);
        EndPaint(hwnd, &ps);
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
